## rrdtool 1.2.27

=== netware/Makefile ===
# Gnu Makefile for NetWare target
# for use with gcc/nlmconv or Metrowerks CodeWarrior compiler
# use with: make -f Makefile [help|all|clean|dev|devclean|dist|distclean]
#
# $id: $
#

DESCR	= Round Robin Database Tool $(RRD_VERSION_STR)
COPYR	= Copyright (c) 1997-2007 by Tobias Oetiker
WWWURL	= http://www.rrdtool.org/
MTSAFE	= YES
#SCREEN	= $(DESCR)
STACK	= 65535
# Comment the line below if you dont want to load protected automatically.
#LDRING	= 3

# You can set the default font used in graphs.
# If not set here RRD defaults to DejaVuSansMono-Roman.ttf
#RRD_DEFAULT_FONT = "sys:/java/nwgfx/lib/x11/fonts/ttf/tt0003m_.ttf"
#RRD_DEFAULT_FONT = "VeraMono.ttf"

# Vertical label angle: 90.0 (default) or 270.0
RRDGRAPH_YLEGEND_ANGLE = 90.0

# Set to one if you want to have piecharts.
WITH_PIECHART = 0

# Set the extension used for rrdcgi.
ifndef CGIEXT
CGIEXT	= nlm
endif

# Edit the path below to point to your Novell NDK.
ifndef NDKBASE
NDKBASE	= c:/novell
endif

# Base for the lib sources
ifndef LIBBASE
LIBBASE	= ../..
endif
# All library code is statically linked to avoid problems with other lib NLMs.
# Edit the path below to point to your libpng sources or set environment var.
ifndef LIBPNG
LIBPNG	= $(LIBBASE)/libpng-1.2.23
endif
# Edit the path below to point to your freetype sources or set environment var.
ifndef LIBFT2
LIBFT2	= $(LIBBASE)/freetype-2.3.5
endif
# Edit the path below to point to your libart sources or set environment var.
ifndef LIBART
LIBART	= $(LIBBASE)/libart_lgpl-2.3.17
endif
# Edit the path below to point to your zlib sources or set environment var.
ifndef ZLIBSDK
ZLIBSDK	= $(LIBBASE)/zlib-1.2.3
endif

# Edit the path below to point to your distribution folder.
ifndef DISTDIR
DISTDIR	= rrdtool-$(RRD_VERSION_STR)-nw
endif
ifndef DISTARC
DISTARC = $(DISTDIR).$(ARCEXT)
endif

# Edit the path below to point to your distribution folder.
ifndef DEVLDIR
DEVLDIR	= rrdtool-$(RRD_VERSION_STR)-sdk-nw
endif
ifndef DEVLARC
DEVLARC = $(DEVLDIR).$(ARCEXT)
endif

# whatever...
# NO_NULL_REALLOC = 1

# Edit the var below to point to your lib architecture.
ifndef LIBARCH
# LIBARCH = CLIB
LIBARCH = LIBC
endif

# The following line defines your compiler.
ifdef METROWERKS
	CC = mwccnlm
else
	CC = gcc
endif
# RM	= rm -f
CP	= cp -afv
# if you want to mark the target as MTSAFE you will need a tool for
# generating the xdc data for the linker; here's a minimal tool:
# http://www.gknw.net/development/prgtools/mkxdc.zip
MPKXDC	= mkxdc
# CodeWarrior is too stupid to set the internal name properly when
# the extension is not a NLM and not a registered type. So we need
# to fix that after linking (since CGI isnt a known type - argh!):
# http://www.gknw.net/development/prgtools/fixnlmname.zip
FIXNLMN	= fixnlmname #-q
# Here you can find a native Win32 binary of the original awk:
# http://www.gknw.net/development/prgtools/awk.zip
AWK	= awk
MV	= mv -fv
ifndef ARCBIN
ARCBIN	= zip -qzr9
ARCEXT	= zip
#ARCBIN	= 7za a
#ARCEXT	= 7z
endif


# must be equal to DEBUG or NDEBUG
DB	= NDEBUG
# DB	= DEBUG
# Optimization: -O<n> or debugging: -g
ifeq ($(DB),NDEBUG)
	OPT	= -O2
	OBJDIR	= release
else
	OPT	= -g
	OBJDIR	= debug
endif

# Project root
PROOT	= ..

# Include the version info retrieved from source.
-include $(OBJDIR)/version.inc

# Global flags for all compilers
CFLAGS	= $(OPT) -D$(DB) -nostdinc -DNETWARE -DN_PLAT_NLM -D_POSIX_SOURCE
CFLAGS	+= -DHAVE_CONFIG_H

ifeq ($(CC),mwccnlm)
LD	= mwldnlm
LDFLAGS	= -nostdlib $^ $(PRELUDE) $(LDLIBS) -o $@ -commandfile
AR	= $(LD)
ARFLAGS	= -nostdlib -type library -o
LIBEXT	= lib
#RANLIB	=
CFLAGS	+= -gccinc -inline off -opt nointrinsics -proc 586
CFLAGS	+= -relax_pointers
#CFLAGS	+= -w on,nounused,nounusedexpr # -ansi strict
ifeq ($(LIBARCH),LIBC)
	PRELUDE = $(SDK_LIBC)/imports/libcpre.o
	CFLAGS += -align 4
else
	PRELUDE = "$(METROWERKS)/Novell Support/libraries/runtime/prelude.obj"
	CFLAGS += -include "$(METROWERKS)/Novell Support/headers/nlm_prefix.h"
	CFLAGS += -align 1
endif
else
LD	= nlmconv
LDFLAGS	= -T
AR	= ar
ARFLAGS	= -cq
LIBEXT	= a
RANLIB	= ranlib
CFLAGS	+= -fno-builtin -fpcc-struct-return -fno-strict-aliasing
CFLAGS	+= -Wall -Wno-unused # -pedantic
ifeq ($(LIBARCH),LIBC)
	PRELUDE = $(SDK_LIBC)/imports/libcpre.gcc.o
else
	PRELUDE = $(NDK_ROOT)/pre/prelude.o
	CFLAGS += -include $(NDKBASE)/nlmconv/genlm.h
endif
endif

ifeq ($(findstring linux,$(OSTYPE)),linux)
#include $(NDKBASE)/nlmconv/ncpfs.inc
DL	= '
DS	= /
else
DS	= \\
endif

ifeq ($(MTSAFE),YES)
	XDCOPT = -n
endif
ifeq ($(MTSAFE),NO)
	XDCOPT = -u
endif
ifndef DESCR
	DESCR = $(notdir $(@:.def=)) Command Extension
endif
DESCR += ($(LIBARCH)) - $(CC) build

NDK_ROOT = $(NDKBASE)/ndk
SDK_CLIB = $(NDK_ROOT)/nwsdk
SDK_LIBC = $(NDK_ROOT)/libc

INCLUDES += -I$(PROOT) -I$(PROOT)/src -I$(LIBPNG) -I$(LIBFT2)/include -I$(LIBART) -I$(ZLIBSDK)

ifeq ($(LIBARCH),LIBC)
	INCLUDES += -I$(SDK_LIBC)/include -I$(SDK_LIBC)/include/nks
else
	INCLUDES += -I$(SDK_CLIB)/include/nlm -I$(SDK_CLIB)/include
endif

CFLAGS += $(INCLUDES)

vpath %.c $(PROOT)/src $(LIBPNG) $(LIBART)/libart_lgpl $(ZLIBSDK)

RRDLIBOBJS	= \
	$(OBJDIR)/rrd_afm.o \
	$(OBJDIR)/rrd_afm_data.o \
	$(OBJDIR)/rrd_create.o \
	$(OBJDIR)/rrd_diff.o \
	$(OBJDIR)/rrd_dump.o \
	$(OBJDIR)/rrd_error.o \
	$(OBJDIR)/rrd_fetch.o \
	$(OBJDIR)/rrd_first.o \
	$(OBJDIR)/rrd_format.o \
	$(OBJDIR)/rrd_gfx.o \
	$(OBJDIR)/rrd_graph.o \
	$(OBJDIR)/rrd_graph_helper.o \
	$(OBJDIR)/rrd_hw.o \
	$(OBJDIR)/rrd_info.o \
	$(OBJDIR)/rrd_last.o \
	$(OBJDIR)/rrd_lastupdate.o \
	$(OBJDIR)/rrd_nan_inf.o \
	$(OBJDIR)/rrd_open.o \
	$(OBJDIR)/rrd_resize.o \
	$(OBJDIR)/rrd_restore.o \
	$(OBJDIR)/rrd_rpncalc.o \
	$(OBJDIR)/rrd_tune.o \
	$(OBJDIR)/rrd_update.o \
	$(OBJDIR)/rrd_version.o \
	$(OBJDIR)/rrd_xport.o \
	$(OBJDIR)/rrd_thread_safe.o \
	$(EOLIST)

XLIBOBJS	= \
	$(OBJDIR)/rrd_getopt.o \
	$(OBJDIR)/rrd_getopt1.o \
	$(OBJDIR)/art_rgba_svp.o \
	$(OBJDIR)/hash_32.o \
	$(OBJDIR)/parsetime.o \
	$(OBJDIR)/pngsize.o \
	$(EOLIST)

PNGLIBOBJS	= \
	$(OBJDIR)/png.o \
	$(OBJDIR)/pngerror.o \
	$(OBJDIR)/pngget.o \
	$(OBJDIR)/pngmem.o \
	$(OBJDIR)/pngpread.o \
	$(OBJDIR)/pngread.o \
	$(OBJDIR)/pngrio.o \
	$(OBJDIR)/pngrtran.o \
	$(OBJDIR)/pngrutil.o \
	$(OBJDIR)/pngset.o \
	$(OBJDIR)/pngtrans.o \
	$(OBJDIR)/pngwio.o \
	$(OBJDIR)/pngwrite.o \
	$(OBJDIR)/pngwtran.o \
	$(OBJDIR)/pngwutil.o \
	$(EOLIST)
ifeq "$(wildcard $(LIBPNG)/pnggccrd.c)" "$(LIBPNG)/pnggccrd.c"
PNGLIBOBJS	+= \
	$(OBJDIR)/pnggccrd.o \
	$(OBJDIR)/pngvcrd.o \
	$(EOLIST)
endif

ZLIBOBJS	= \
	$(OBJDIR)/adler32.o \
	$(OBJDIR)/compress.o \
	$(OBJDIR)/crc32.o \
	$(OBJDIR)/deflate.o \
	$(OBJDIR)/inflate.o \
	$(OBJDIR)/inffast.o \
	$(OBJDIR)/inftrees.o \
	$(OBJDIR)/trees.o \
	$(OBJDIR)/zutil.o \
	$(EOLIST)
ifeq "$(wildcard $(ZLIBSDK)/infblock.c)" "$(ZLIBSDK)/infblock.c"
ZLIBOBJS	+= \
	$(OBJDIR)/infblock.o \
	$(OBJDIR)/infcodes.o \
	$(OBJDIR)/infutil.o \
	$(EOLIST)
endif

ARTLIBOBJS	= \
	$(patsubst $(LIBART)/libart_lgpl/%.c,$(OBJDIR)/%.o,$(wildcard $(LIBART)/libart_lgpl/art_*.c))

OBJS	:= $(RRDLIBOBJS) $(XLIBOBJS) $(PNGLIBOBJS) $(ARTLIBOBJS) $(ZLIBOBJS)
OBJCGI	:= $(OBJS) $(OBJDIR)/rrd_cgi.o
OBJTOOL	:= $(OBJS) $(OBJDIR)/rrd_tool.o

LDLIBS	+= $(LIBFT2)/builds/netware/LIBC/libft2.$(LIBEXT)


all: rrdtool rrdcgi

rrdtool: $(OBJDIR) $(PROOT)/rrd_config.h $(OBJDIR)/rrdtool.nlm
rrdcgi: $(OBJDIR) $(PROOT)/rrd_config.h $(OBJDIR)/rrdcgi.$(CGIEXT)
librrd: $(OBJDIR) $(PROOT)/rrd_config.h $(OBJDIR)/librrd.$(LIBEXT)

FORCE: ;

dist: all $(DISTDIR) $(DISTDIR)/readme.txt
	@-$(CP) $(OBJDIR)/rrdcgi.$(CGIEXT) $(DISTDIR)
	@-$(CP) $(OBJDIR)/rrdtool.nlm $(DISTDIR)
	@-$(CP) $(PROOT)/src/*.ttf $(DISTDIR)
	@-$(CP) $(PROOT)/CHANGES $(DISTDIR)
	@-$(CP) $(PROOT)/COPYING $(DISTDIR)
	@-$(CP) $(PROOT)/COPYRIGHT $(DISTDIR)
	@-$(CP) $(PROOT)/NEWS $(DISTDIR)
	@-$(CP) $(PROOT)/README $(DISTDIR)
	@echo Creating $(DISTARC)
	@$(ARCBIN) $(DISTARC) $(DISTDIR)/* < $(DISTDIR)/readme.txt

dev: librrd $(DEVLDIR) $(DEVLDIR)/readme.txt
	@-mkdir $(DEVLDIR)$(DS)include
	@-mkdir $(DEVLDIR)$(DS)lib
	@-mkdir $(DEVLDIR)$(DS)src
	@-$(CP) $(OBJDIR)/librrd.$(LIBEXT) $(DEVLDIR)/lib
	@-$(CP) $(PROOT)/rrd_config.h $(DEVLDIR)/include
	@-$(CP) $(PROOT)/src/rrd.h $(DEVLDIR)/include
	@-$(CP) $(PROOT)/src/*.ttf $(DEVLDIR)/src
	@-$(CP) $(PROOT)/CHANGES $(DEVLDIR)
	@-$(CP) $(PROOT)/COPYING $(DEVLDIR)
	@-$(CP) $(PROOT)/COPYRIGHT $(DEVLDIR)
	@-$(CP) $(PROOT)/NEWS $(DEVLDIR)
	@-$(CP) $(PROOT)/README $(DEVLDIR)
	@echo Creating $(DEVLARC)
	@$(ARCBIN) $(DEVLARC) $(DEVLDIR)/* < $(DEVLDIR)/readme.txt

clean:
	-$(RM) -r $(OBJDIR)
	-$(RM) $(PROOT)/rrd_config.h

distclean: clean
	-$(RM) -r $(DISTDIR)
	-$(RM) $(DISTARC)

devclean: clean
	-$(RM) -r $(DEVLDIR)
	-$(RM) $(DEVLARC)

$(OBJDIR):
	@mkdir $@

$(DISTDIR):
	@mkdir $@

$(DEVLDIR):
	@mkdir $@

$(OBJDIR)/version.inc: $(PROOT)/configure.ac $(OBJDIR) $(PROOT)/src/get_ver.awk
	@echo Creating $@
	@$(AWK) -f $(PROOT)/src/get_ver.awk $< > $@

$(OBJDIR)/%.o: %.c
	@echo Compiling $<
	@$(CC) $(CFLAGS) -c $< -o $@

$(OBJDIR)/rrdcgi.$(CGIEXT): $(OBJCGI) $(OBJDIR)/rrdcgi.def $(OBJDIR)/rrdcgi.xdc
	@echo Linking $@
	@-$(RM) $@
	@$(LD) $(LDFLAGS) $(@:.$(CGIEXT)=.def)
ifeq ($(LD),nlmconv)
	@$(MV) $(notdir $@) $@
endif
ifneq ($(CGIEXT),nlm)
ifeq ($(LD),mwldnlm)
	@$(FIXNLMN) $@
endif
endif

$(OBJDIR)/rrdtool.nlm: $(OBJTOOL) $(OBJDIR)/rrdtool.def $(OBJDIR)/rrdtool.xdc
	@echo Linking $@
	@-$(RM) $@
	@$(LD) $(LDFLAGS) $(@:.nlm=.def)
ifeq ($(LD),nlmconv)
	@$(MV) $(notdir $@) $@
endif

$(OBJDIR)/librrd.$(LIBEXT): $(OBJS)
	@echo Creating $@
	@-$(RM) $@
	@$(AR) $(ARFLAGS) $@ $^
ifdef RANLIB
	@$(RANLIB) $@
endif

$(OBJDIR)/%.xdc: Makefile
	@echo Creating $@
	@$(MPKXDC) $(XDCOPT) $@

$(OBJDIR)/%.def: Makefile $(OBJDIR)/version.inc
	@echo $(DL)# DEF Linker File for use with gcc and nlmconv$(DL) > $@
	@echo $(DL)# or with Codewarrior command line compiler.$(DL) >> $@
	@echo $(DL)# Do not edit this file - it is created by make!$(DL) >> $@
	@echo $(DL)# All your changes will be lost!!$(DL) >> $@
	@echo $(DL)#$(DL) >> $@
	@echo $(DL)copyright "$(COPYR)"$(DL) >> $@
	@echo $(DL)description "$(DESCR)"$(DL) >> $@
	@echo $(DL)version $(RRD_VERSION)$(DL) >> $@
ifdef NLMTYPE
	@echo $(DL)type $(NLMTYPE)$(DL) >> $@
else
	@echo $(DL)type 0$(DL) >> $@
endif
ifdef STACK
	@echo $(DL)stack $(STACK)$(DL) >> $@
endif
	@echo $(DL)threadname "$(notdir $(@:.def=))"$(DL) >> $@
ifdef SCREEN
	@echo $(DL)screenname "$(SCREEN)"$(DL) >> $@
else
	@echo $(DL)screenname "DEFAULT"$(DL) >> $@
endif
ifeq ($(DB),DEBUG)
	@echo $(DL)debug$(DL) >> $@
endif
ifeq ($(LIBARCH),CLIB)
	@echo $(DL)start _Prelude$(DL) >> $@
	@echo $(DL)exit _Stop$(DL) >> $@
	@echo $(DL)import @$(NDK_ROOT)/nwsdk/imports/clib.imp$(DL) >> $@
	@echo $(DL)import @$(NDK_ROOT)/nwsdk/imports/threads.imp$(DL) >> $@
	@echo $(DL)import @$(NDK_ROOT)/nwsdk/imports/nlmlib.imp$(DL) >> $@
	@echo $(DL)module clib$(DL) >> $@
else
	@echo $(DL)start _LibCPrelude$(DL) >> $@
	@echo $(DL)exit _LibCPostlude$(DL) >> $@
	@echo $(DL)check _LibCCheckUnload$(DL) >> $@
	@echo $(DL)import @$(NDK_ROOT)/libc/imports/libc.imp$(DL) >> $@
	@echo $(DL)import @$(NDK_ROOT)/libc/imports/netware.imp$(DL) >> $@
	@echo $(DL)module libc$(DL) >> $@
	@echo $(DL)pseudopreemption$(DL) >> $@
	@echo $(DL)flag_on 64$(DL) >> $@
endif
ifeq ($(LDRING),0)
	@echo $(DL)flag_on 16$(DL) >> $@
endif
ifeq ($(LDRING),3)
	@echo $(DL)flag_on 512$(DL) >> $@
endif
ifdef XDCOPT
	@echo $(DL)xdcdata $(@:.def=.xdc)$(DL) >> $@
endif
ifeq ($(LD),nlmconv)
	@echo $(DL)input $(OBJS) $(LDLIBS)$(DL) >> $@
	@echo $(DL)input $(PRELUDE)$(DL) >> $@
	@echo $(DL)output $(notdir $(@:.def=.nlm))$(DL) >> $@
endif

$(PROOT)/rrd_config.h: FORCE Makefile $(OBJDIR)/version.inc
	@echo Creating $@
	@echo $(DL)/* $(notdir $@) for NetWare target.$(DL) > $@
	@echo $(DL)** Do not edit this file - it is created by make!$(DL) >> $@
	@echo $(DL)** All your changes will be lost!!$(DL) >> $@
	@echo $(DL)*/$(DL) >> $@
	@echo $(DL)#ifndef NETWARE$(DL) >> $@
	@echo $(DL)#error This $(notdir $@) is created for NetWare platform!$(DL) >> $@
	@echo $(DL)#endif$(DL) >> $@
	@echo $(DL)#ifndef RRD_CONFIG_H$(DL) >> $@
	@echo $(DL)#define RRD_CONFIG_H$(DL) >> $@

=== win32/Makefile ===
# Gnu Makefile for Win32 target
# for use with MingW32 gcc or Metrowerks CodeWarrior compiler
# use with: make -f Makefile [help|all|clean|dev|devclean|dist|distclean]
#
# $id: $
#

DESCR	= Round Robin Database Tool
COPYR	= Copyright (c) 1997-2007 by Tobias Oetiker
WWWURL	= http://www.rrdtool.org/
ICON	= $(PROOT)/favicon.ico

# You can set the default font used in graphs.
# If not set here RRD defaults to DejaVuSansMono-Roman.ttf
#RRD_DEFAULT_FONT = "arial.ttf"
#RRD_DEFAULT_FONT = "VeraMono.ttf"

# Vertical label angle: 90.0 (default) or 270.0
RRDGRAPH_YLEGEND_ANGLE = 90.0

# Set to one if you want to have piecharts.
WITH_PIECHART = 0

# Set the extension used for rrdcgi.
ifndef CGIEXT
CGIEXT	= exe
endif

# Base for the lib sources
ifndef LIBBASE
LIBBASE	= ../..
endif
# All library code is statically linked to avoid problems with other lib DLLs.
# Edit the path below to point to your libpng sources or set environment var.
ifndef LIBPNG
LIBPNG	= $(LIBBASE)/libpng-1.2.23
endif
# Edit the path below to point to your freetype sources or set environment var.
ifndef LIBFT2
#LIBFT2	= $(LIBBASE)/freetype-2.3.5
LIBFT2	= $(LIBBASE)/../mingw32/freetype-2.3.5
endif
# Edit the path below to point to your libart sources or set environment var.
ifndef LIBART
LIBART	= $(LIBBASE)/libart_lgpl-2.3.17
endif
# Edit the path below to point to your zlib sources or set environment var.
ifndef ZLIBSDK
ZLIBSDK	= $(LIBBASE)/zlib-1.2.3
endif

# Edit the path below to point to your distribution folder.
ifndef DISTDIR
DISTDIR	= rrdtool-$(RRD_VERSION_STR)-w32
endif
ifndef DISTARC
DISTARC = $(DISTDIR).$(ARCEXT)
endif

# Edit the path below to point to your distribution folder.
ifndef DEVLDIR
DEVLDIR	= rrdtool-$(RRD_VERSION_STR)-sdk-w32
endif
ifndef DEVLARC
DEVLARC = $(DEVLDIR).$(ARCEXT)
endif

# whatever...
NO_NULL_REALLOC = 1

# The following line defines your compiler.
ifdef METROWERKS
	CC = mwcc
else
	CC = $(CRPREFIX)gcc
endif
# RM	= rm -f
CP	= cp -afv
# Here you can find a native Win32 binary of the original awk:
# http://www.gknw.net/development/prgtools/awk.zip
AWK	= awk
ifndef ARCBIN
ARCBIN	= zip -qzr9
ARCEXT	= zip
#ARCBIN	= 7za a
#ARCEXT	= 7z
endif

# must be equal to DEBUG or NDEBUG
DB	= NDEBUG
# DB	= DEBUG
# Optimization: -O<n> or debugging: -g
ifeq ($(DB),NDEBUG)
	OPT	= -O2
	OBJDIR	= release
else
	OPT	= -g
	OBJDIR	= debug
endif

# Project root
PROOT	= ..

# Include the version info retrieved from source.
-include $(OBJDIR)/version.inc

# Global flags for all compilers
CFLAGS	= $(OPT) -D$(DB) -DHAVE_CONFIG_H

ifeq ($(CC),mwcc)
LD	= mwld
RC	= mwwinrc
LDFLAGS	= -nostdlib
AR	= $(LD)
ARFLAGS	= -type library -w nocmdline $(OBJS) -o
LIBEXT	= lib
LIBPATH	+= -lr "$(METROWERKS)/MSL" -lr "$(METROWERKS)/Win32-x86 Support"
LDLIBS	+= -lkernel32.lib -luser32.lib
LDLIBS	+= -lMSL_Runtime_x86.lib -lMSL_C_x86.lib -lMSL_Extras_x86.lib
RCFLAGS	=
CFLAGS	+= -DWIN32
CFLAGS	+= -nostdinc -gccinc -msgstyle gcc -inline off -opt nointrinsics -proc 586
CFLAGS	+= -ir "$(METROWERKS)/MSL" -ir "$(METROWERKS)/Win32-x86 Support"
CFLAGS	+= -w on,nounused,nounusedexpr # -ansi strict
else
LD	= $(CRPREFIX)gcc
RC	= $(CRPREFIX)windres
LDFLAGS	= -s
AR	= ar
ARFLAGS	= -cq
LIBEXT	= a
RCFLAGS	= -O coff -i
CFLAGS	+= -fno-strict-aliasing
CFLAGS	+= -Wall -Wno-unused # -pedantic
endif

ifdef __MSYS__
DL	= '
DS	= /
else
DS	= \\
endif

ifndef DESCR
	DESCR = $(notdir $(@:.rc=)) Command Extension
endif
DESCR += - $(CC) build

INCLUDES += -I$(PROOT) -I$(PROOT)/src -I$(LIBPNG) -I$(LIBFT2)/include -I$(LIBART) -I$(ZLIBSDK)

CFLAGS += $(INCLUDES)

vpath %.c $(PROOT)/src $(LIBPNG) $(LIBART)/libart_lgpl $(ZLIBSDK)

RRDLIBOBJS	= \
	$(OBJDIR)/rrd_afm.o \
	$(OBJDIR)/rrd_afm_data.o \
	$(OBJDIR)/rrd_create.o \
	$(OBJDIR)/rrd_diff.o \
	$(OBJDIR)/rrd_dump.o \
	$(OBJDIR)/rrd_error.o \
	$(OBJDIR)/rrd_fetch.o \
	$(OBJDIR)/rrd_first.o \
	$(OBJDIR)/rrd_format.o \
	$(OBJDIR)/rrd_gfx.o \
	$(OBJDIR)/rrd_graph.o \
	$(OBJDIR)/rrd_graph_helper.o \
	$(OBJDIR)/rrd_hw.o \
	$(OBJDIR)/rrd_info.o \
	$(OBJDIR)/rrd_last.o \
	$(OBJDIR)/rrd_lastupdate.o \
	$(OBJDIR)/rrd_nan_inf.o \
	$(OBJDIR)/rrd_open.o \
	$(OBJDIR)/rrd_resize.o \
	$(OBJDIR)/rrd_restore.o \
	$(OBJDIR)/rrd_rpncalc.o \
	$(OBJDIR)/rrd_tune.o \
	$(OBJDIR)/rrd_update.o \
	$(OBJDIR)/rrd_version.o \
	$(OBJDIR)/rrd_xport.o \
	$(OBJDIR)/rrd_thread_safe_nt.o \
	$(EOLIST)

XLIBOBJS	= \
	$(OBJDIR)/rrd_getopt.o \
	$(OBJDIR)/rrd_getopt1.o \
	$(OBJDIR)/art_rgba_svp.o \
	$(OBJDIR)/hash_32.o \
	$(OBJDIR)/parsetime.o \
	$(OBJDIR)/pngsize.o \
	$(OBJDIR)/strftime.o \
	$(EOLIST)

PNGLIBOBJS	= \
	$(OBJDIR)/png.o \
	$(OBJDIR)/pngerror.o \
	$(OBJDIR)/pngget.o \
	$(OBJDIR)/pngmem.o \
	$(OBJDIR)/pngpread.o \
	$(OBJDIR)/pngread.o \
	$(OBJDIR)/pngrio.o \
	$(OBJDIR)/pngrtran.o \
	$(OBJDIR)/pngrutil.o \
	$(OBJDIR)/pngset.o \
	$(OBJDIR)/pngtrans.o \
	$(OBJDIR)/pngwio.o \
	$(OBJDIR)/pngwrite.o \
	$(OBJDIR)/pngwtran.o \
	$(OBJDIR)/pngwutil.o \
	$(EOLIST)
ifeq "$(wildcard $(LIBPNG)/pnggccrd.c)" "$(LIBPNG)/pnggccrd.c"
PNGLIBOBJS	+= \
	$(OBJDIR)/pnggccrd.o \
	$(OBJDIR)/pngvcrd.o \
	$(EOLIST)
endif

ZLIBOBJS	= \
	$(OBJDIR)/adler32.o \
	$(OBJDIR)/compress.o \
	$(OBJDIR)/crc32.o \
	$(OBJDIR)/deflate.o \
	$(OBJDIR)/inflate.o \
	$(OBJDIR)/inffast.o \
	$(OBJDIR)/inftrees.o \
	$(OBJDIR)/trees.o \
	$(OBJDIR)/zutil.o \
	$(EOLIST)
ifeq "$(wildcard $(ZLIBSDK)/infblock.c)" "$(ZLIBSDK)/infblock.c"
ZLIBOBJS	+= \
	$(OBJDIR)/infblock.o \
	$(OBJDIR)/infcodes.o \
	$(OBJDIR)/infutil.o \
	$(EOLIST)
endif

ARTLIBOBJS	= \
	$(patsubst $(LIBART)/libart_lgpl/%.c,$(OBJDIR)/%.o,$(wildcard $(LIBART)/libart_lgpl/art_*.c))

OBJS	:= $(RRDLIBOBJS) $(XLIBOBJS) $(PNGLIBOBJS) $(ARTLIBOBJS) $(ZLIBOBJS)
OBJCGI	:= $(OBJS) $(OBJDIR)/rrd_cgi.o
OBJTOOL	:= $(OBJS) $(OBJDIR)/rrd_tool.o

LDLIBS	+= $(LIBFT2)/objs/freetype.$(LIBEXT)


all: rrdtool rrdcgi

rrdtool: $(OBJDIR) $(PROOT)/rrd_config.h $(OBJDIR)/rrdtool.exe
rrdcgi: $(OBJDIR) $(PROOT)/rrd_config.h $(OBJDIR)/rrdcgi.$(CGIEXT)
librrd: $(OBJDIR) $(PROOT)/rrd_config.h $(OBJDIR)/librrd.$(LIBEXT)

FORCE: ;

dist: all $(DISTDIR) $(DISTDIR)/readme.txt
	@-$(CP) $(OBJDIR)/rrdcgi.$(CGIEXT) $(DISTDIR)
	@-$(CP) $(OBJDIR)/rrdtool.exe $(DISTDIR)
	@-$(CP) $(PROOT)/src/*.ttf $(DISTDIR)
	@-$(CP) $(PROOT)/CHANGES $(DISTDIR)
	@-$(CP) $(PROOT)/COPYING $(DISTDIR)
	@-$(CP) $(PROOT)/COPYRIGHT $(DISTDIR)
	@-$(CP) $(PROOT)/NEWS $(DISTDIR)
	@-$(CP) $(PROOT)/README $(DISTDIR)
	@echo Creating $(DISTARC)
	@$(ARCBIN) $(DISTARC) $(DISTDIR)/* < $(DISTDIR)/readme.txt

dev: librrd $(DEVLDIR) $(DEVLDIR)/readme.txt
	@-mkdir $(DEVLDIR)$(DS)include
	@-mkdir $(DEVLDIR)$(DS)lib
	@-mkdir $(DEVLDIR)$(DS)src
	@-$(CP) $(OBJDIR)/librrd.$(LIBEXT) $(DEVLDIR)/lib
	@-$(CP) $(PROOT)/rrd_config.h $(DEVLDIR)/include
	@-$(CP) $(PROOT)/src/rrd.h $(DEVLDIR)/include
	@-$(CP) $(PROOT)/src/*.ttf $(DEVLDIR)/src
	@-$(CP) $(PROOT)/CHANGES $(DEVLDIR)
	@-$(CP) $(PROOT)/COPYING $(DEVLDIR)
	@-$(CP) $(PROOT)/COPYRIGHT $(DEVLDIR)
	@-$(CP) $(PROOT)/NEWS $(DEVLDIR)
	@-$(CP) $(PROOT)/README $(DEVLDIR)
	@echo Creating $(DEVLARC)
	@$(ARCBIN) $(DEVLARC) $(DEVLDIR)/* < $(DEVLDIR)/readme.txt

clean:
	-$(RM) -r $(OBJDIR)
	-$(RM) $(PROOT)/rrd_config.h

distclean: clean
	-$(RM) -r $(DISTDIR)
	-$(RM) $(DISTARC)

devclean: clean
	-$(RM) -r $(DEVLDIR)
	-$(RM) $(DEVLARC)

$(OBJDIR):
	@mkdir $@

$(DISTDIR):
	@mkdir $@

$(DEVLDIR):
	@mkdir $@

$(OBJDIR)/version.inc: $(PROOT)/configure.ac $(OBJDIR) $(PROOT)/src/get_ver.awk
	@echo Creating $@
	@$(AWK) -f $(PROOT)/src/get_ver.awk $< > $@

$(OBJDIR)/%.o: %.c
	@echo Compiling $<
	@$(CC) $(CFLAGS) -c $< -o $@

$(OBJDIR)/rrdcgi.$(CGIEXT): $(OBJCGI) $(OBJDIR)/rrdcgi.res
	@echo Linking $@
	@-$(RM) $@
	@$(LD) $(LDFLAGS) $^ -o $@ $(LIBPATH) $(LDLIBS)

$(OBJDIR)/rrdtool.exe: $(OBJTOOL) $(OBJDIR)/rrdtool.res
	@echo Linking $@
	@-$(RM) $@
	@$(LD) $(LDFLAGS) $^ -o $@ $(LIBPATH) $(LDLIBS)

$(OBJDIR)/librrd.$(LIBEXT): $(OBJS)
	@echo Creating $@
	@-$(RM) $@
	@$(AR) $(ARFLAGS) $@ $^

$(OBJDIR)/%.res: $(OBJDIR)/%.rc
	@echo Creating $@
	@$(RC) $(RCFLAGS) $< -o $@

$(OBJDIR)/%.rc: Makefile $(OBJDIR)/version.inc
	@echo $(DL)1 VERSIONINFO$(DL) > $@
	@echo $(DL) FILEVERSION $(RRD_VERSION),0$(DL) >> $@
	@echo $(DL) PRODUCTVERSION $(RRD_VERSION),0$(DL) >> $@
	@echo $(DL) FILEFLAGSMASK 0x3fL$(DL) >> $@
	@echo $(DL) FILEOS 0x40004L$(DL) >> $@
	@echo $(DL) FILEFLAGS 0x0L$(DL) >> $@
	@echo $(DL) FILETYPE 0x1L$(DL) >> $@
	@echo $(DL) FILESUBTYPE 0x0L$(DL) >> $@
	@echo $(DL)BEGIN$(DL) >> $@
	@echo $(DL)  BLOCK "StringFileInfo"$(DL) >> $@
	@echo $(DL)  BEGIN$(DL) >> $@
	@echo $(DL)    BLOCK "040904E4"$(DL) >> $@
	@echo $(DL)    BEGIN$(DL) >> $@
	@echo $(DL)      VALUE "LegalCopyright","$(COPYR)\0"$(DL) >> $@
ifdef COMPANY
	@echo $(DL)      VALUE "CompanyName","$(COMPANY)\0"$(DL) >> $@
endif
	@echo $(DL)      VALUE "ProductName","$(notdir $(@:.rc=.exe))\0"$(DL) >> $@
	@echo $(DL)      VALUE "ProductVersion","$(RRD_VERSION_STR)\0"$(DL) >> $@
	@echo $(DL)      VALUE "License","Released under GPL.\0"$(DL) >> $@
	@echo $(DL)      VALUE "FileDescription","$(DESCR)\0"$(DL) >> $@
	@echo $(DL)      VALUE "FileVersion","$(RRD_VERSION_STR)\0"$(DL) >> $@
	@echo $(DL)      VALUE "InternalName","$(notdir $(@:.rc=))\0"$(DL) >> $@
	@echo $(DL)      VALUE "OriginalFilename","$(notdir $(@:.rc=.exe))\0"$(DL) >> $@
	@echo $(DL)      VALUE "WWW","$(WWWURL)\0"$(DL) >> $@
	@echo $(DL)    END$(DL) >> $@
	@echo $(DL)  END$(DL) >> $@
	@echo $(DL)  BLOCK "VarFileInfo"$(DL) >> $@
	@echo $(DL)  BEGIN$(DL) >> $@
	@echo $(DL)    VALUE "Translation", 0x409, 1252$(DL) >> $@
	@echo $(DL)  END$(DL) >> $@
	@echo $(DL)END$(DL) >> $@
ifdef ICON
	@echo $(DL)10 ICON DISCARDABLE "$(ICON)"$(DL) >> $@
endif

$(PROOT)/rrd_config.h: FORCE Makefile $(OBJDIR)/version.inc
	@echo Creating $@
	@echo $(DL)/* $(notdir $@) for Win32 target.$(DL) > $@
	@echo $(DL)** Do not edit this file - it is created by make!$(DL) >> $@
	@echo $(DL)** All your changes will be lost!!$(DL) >> $@
	@echo $(DL)*/$(DL) >> $@
	@echo $(DL)#ifndef WIN32$(DL) >> $@
	@echo $(DL)#error This $(notdir $@) is created for Win32 platform!$(DL) >> $@
	@echo $(DL)#endif$(DL) >> $@
	@echo $(DL)#ifndef RRD_CONFIG_H$(DL) >> $@
	@echo $(DL)#define RRD_CONFIG_H$(DL) >> $@
	@echo $(DL)#define OS "i586-pc-Win32"$(DL) >> $@
	@echo $(DL)#define PACKAGE_VERSION "$(RRD_VERSION_STR)"$(DL) >> $@
	@echo $(DL)#define PACKAGE_BUGREPORT "tobi@oetiker.ch"$(DL) >> $@
	@echo $(DL)#define NUMVERS $(RRD_NUMVERS)$(DL) >> $@
	@echo $(DL)#define HAVE_ASSERT_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_DLFCN_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_DLOPEN 1$(DL) >> $@
	@echo $(DL)#define HAVE_ERRNO_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_FCNTL_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_FIONBIO 1$(DL) >> $@
	@echo $(DL)#define HAVE_INTTYPES_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_LIMITS_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_LONGLONG 1$(DL) >> $@
	@echo $(DL)#define HAVE_LOCALE_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_MALLOC_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_MATH_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_MBSTOWCS 1$(DL) >> $@
	@echo $(DL)#define HAVE_SETJMP_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_SNPRINTF 1$(DL) >> $@
	@echo $(DL)#define HAVE_STDARG_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_STDDEF_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_STDINT_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_STDLIB_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRCASECMP 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRDUP 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRFTIME 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRING_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRLCAT 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRLCPY 1$(DL) >> $@
	@echo $(DL)#define HAVE_STRSTR 1$(DL) >> $@
	@echo $(DL)#define HAVE_SYS_PARAM_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_SYS_STAT_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_SYS_TIME_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_TIME_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_VSNPRINTF 1$(DL) >> $@
	@echo $(DL)#define STDC_HEADERS 1$(DL) >> $@
	@echo $(DL)#define TIME_WITH_SYS_TIME 1$(DL) >> $@
	@echo $(DL)#define HAVE_ZLIB_H 1$(DL) >> $@
	@echo $(DL)#define HAVE_LIBZ 1$(DL) >> $@
ifdef NO_NULL_REALLOC
	@echo $(DL)#define NO_NULL_REALLOC 1$(DL) >> $@

## rrdtool 1.5.4

=== debian/changelog ===
rrdtool (1.5.4-5) unstable; urgency=medium

  * Removed Multi-Arch:no. (Closes: #795646)
  * Added support for lua5.3.
  * Removed rrdcached from hurd since it uses 'Not implemented' functions.
  * Reduced build and -dev dependencies.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Mon, 17 Aug 2015 16:08:45 +0200

rrdtool (1.5.4-4) unstable; urgency=medium

  * Allowed dh_install to proceed when python-setuptools is not installed.
  * Added patch 390x_first_week_day to fix unit tests on 390x architectures.
  * Enabled Multi-Arch. Partial support due to #117142. Lintian override for
    python debug symbols (See #795275).
  * Enabled perl-shared unit tests.
  * Refreshed lua patches headers: Applied-Upstream.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Fri, 14 Aug 2015 15:26:41 +0200

rrdtool (1.5.4-3) unstable; urgency=medium

  * Added new patches to support lua5.2. Thanks Yolanda Robla.
  * Switched building of lua, perl, python and ruby bindings packages to use
    debhelper specific buildsystems:
    - Created packages lua-rrd and lua-rrd-dev, providing support for both
      lua 5.1 and 5.2. The old packages are now transitional. Added
      dependency on dh_lua.
    - Adjusted cleaning, installing and testing to these systems.
  * Force LC_ALL during the build; Re-enabled rpn2 unit test.
  * Enabled rrdcached unit test.
  * d/control: Dropped pre-Jessie transitions.
  * Dropped unused lintian overrides.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Wed, 12 Aug 2015 17:23:20 +0200

rrdtool (1.5.4-2) unstable; urgency=low

  * Force UTF-8 encoding and UTC timezone on build.
  * patches/breaks-long-man-lines: Force UTF-8.
  * New patch 7digits to limit precision in unit test success checks.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Sun, 09 Aug 2015 22:58:54 +0200

rrdtool (1.5.4-1) unstable; urgency=low

  * Added myself in uploaders.
  * Update d/watch to look dirrectly at github.
  * New upstream version:
    - Fixes json output (Closes: #686825)
    - Fixes rrdupdate duplicate paragraph in man (Closes: #603507)
    - Adds support for floating point values with DERIVE, COUNTER with new
      datasource types: DCOUNTER and DDERIVE. (Closes: #543631)
    - Fixes compilation on hurd. (Closes: #721975)
    - Provide a python example with locale setup. (Closes: #729007).
    - Drop all patches but no-rpath-for-ruby: Applied upstream.
    - Added build-dependency on dc.
    - Ignoring new systemd files that would change the socket location and
      many options. Using upstream lsb files from github. (Closes: #717248,
      #748656)
  * Moved project to alioth: Updated maintainer address and Vcs-* fields.
  * Dropped transitional packages librrd-ruby*.
  * Bumped standards to 3.9.6: No change required.
  * Switch copyright to DEP5 format.
  * Bumped source format to 3.0 (quilt):
    - Dropped d/README.source;
    - Dropped quilt has a dependency.
  * Minimized d/rules:
    - Using dh_auto_configure fixes all hardening but for ruby.
    - Uses /usr/lib/arch-triplet.
    - Clean using d/clean.
  * Enabled verbose build.
  * Re-enabled optimisations on arm. (Closes: #467342)
  * Disable rpn2 unittest that fails.
  * Made the builds reproducible:
    - Set up fake BUILD_DATE and BUILD_TIME in d/rules from changelog.
    - New patch reproducible-builds to use these.
  * Added patch breaks-long-man-lines to fix "Cant break line" warnings.
  * Added librrd4.lintian-overrides for false positive.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Sun, 09 Aug 2015 17:43:02 +0200

rrdtool (1.4.8-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix setlocale calls, causing free'd memory usage. Thanks Matthias Nagel.
    (Closes: #751842)
  * Add libpng-dev as an alternative to libpng12-dev. (Closes: #662494)

 -- Jean-Michel Vourgère <nirgal@debian.org>  Wed, 03 Jun 2015 23:38:18 +0200

rrdtool (1.4.8-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix librrd-ruby symlink to dir (Closes: #768283)
    - New librrd-ruby.maintscript.
    - control: librrd-ruby: Added ${misc:Pre-Depends}.

 -- Jean-Michel Nirgal Vourgère <jmv_deb@nirgal.com>  Sun, 16 Nov 2014 02:11:49 +0000

rrdtool (1.4.8-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix failure to build with perl 5.20 from experimental
    Closes: #752813
    + convert librrds-perl.install to executable script using
      $Config{vendorarch} instead of hardcoding /usr/lib/perl5
    + bump debhelper build-dependency and compat level to 9, needed for having
      an executable .install

 -- Damyan Ivanov <dmn@debian.org>  Mon, 04 Aug 2014 11:16:56 +0000

rrdtool (1.4.8-1) unstable; urgency=medium

  [ Sebastian Harl ]
  * New upstream release; thanks to Alin Dobre for reporting this and
    providing various patches (Closes: #726159):
    - Fixed the xport JSON output format; thanks to Thomas Mainka for
      reporting this (Closes: #686825).
    - Fixed a segfault in rrdcached when using -j on non-existent directories;
      thanks to Witold Baryluk for reporting this (Closes: #663505).
    - Fixed segfault in rrdgraph caused by int32 overflows; thanks to Matej
      Kosik for reporting this (Closes: #451852).
  * Fixed changelog of 1.4.7-2 regarding the versioned build-dep on tcl-dev.
  * Merged 1.4.7-2.1 NMU; thanks to Christian Hofstaedtler (Closes: 736333).
  * debian/patches:
    - Added CVE-2013-2131; upstream patch fixing a format string vulnerability
      in rrdgraph; thanks to Henri Salo for reporting this (Closes: #708866).
      Raised urgency to medium for this.
  * debian/patches, debian/rules, debian/control:
    - Added build_ldadd; patch Makefile to pass $ALL_LIBS to rrdcached's
      linker flags to ensure it's going to be linked against libglib.
    - Build-depend on and use dh-autoreconf to manage the build_ldadd patch.
  * debian/control:
    - Optionally recommend fonts-dejavu-core as (the preferred) alternative to
      ttf-dejavu-core; thanks to Martin-Éric Racine for reporting this


## rrdtool 1.5.5

=== debian/changelog ===
rrdtool (1.5.5-4) unstable; urgency=high

  * Expanded list of files to install. (Closes: #807024)
  * New patch tests_noverbose to disable verbose in tests. This was polluting
    the output, make tests fails, and FTBFS. (Closes: #818156)
  * Bumped policy to 3.9.7: No change required.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Wed, 23 Mar 2016 11:46:12 +0100

rrdtool (1.5.5-3) unstable; urgency=high

  * Updated d/patch/series file. (Closes: #805391)

 -- Jean-Michel Vourgère <nirgal@debian.org>  Sun, 20 Dec 2015 13:58:21 +0100

rrdtool (1.5.5-2) unstable; urgency=high

  * New patch/mmap_memcpy_overlap to fix FTBFS on mips. Thanks to
    Niko Tyni. (Closes: #805391)

 -- Jean-Michel Vourgère <nirgal@debian.org>  Sun, 20 Dec 2015 10:40:55 +0100

rrdtool (1.5.5-1) unstable; urgency=medium

  * New upstream release:
   - Drop patches 7digit and pm_noexec: Applied upstream.
  * Adjusted rrd-lua.lintian-override for lua5.3.
  * Dropped rrdtool-dbg lintian-overrides, fixed in lintian.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Mon, 16 Nov 2015 21:55:40 +0100

=== debian/control ===
Source: rrdtool
Section: utils
Priority: optional
Maintainer: Debian RRDtool Team <pkg-rrdtool-maint@lists.alioth.debian.org>
Uploaders: Sebastian Harl <tokkee@debian.org>,
           Alexander Wirt <formorer@debian.org>,
           Bernd Zeimetz <bzed@debian.org>,
           Jean-Michel Vourgère <nirgal@debian.org>
Standards-Version: 3.9.7
Build-Depends: dc,
               debhelper (>= 9),
               dh-autoreconf,
               dh-exec (>=0.3),
               dh-lua,
               dh-python,
               gem2deb,
               libdbi-dev,
               libpango1.0-dev,
               libpng-dev,
               libxml2-dev,
               perl (>= 5.8.0),
               python-all-dbg (>= 2.6.6-3~),
               python-all-dev (>= 2.6.6-3~),
               tcl-dev (<= 9),
               tcl-dev (>= 8)
Homepage: http://oss.oetiker.ch/rrdtool/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rrdtool/rrdtool.git
Vcs-Git: git://anonscm.debian.org/pkg-rrdtool/rrdtool.git
XS-Ruby-Versions: all

Package: rrdtool
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: librrds-perl
Description: time-series data storage and display system (programs)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 RRDtool is often used via various wrappers that can poll data from devices
 and feed data into RRDs, as well as provide a friendlier user interface and
 customized graphs.
 .
 This package contains command-line programs used to access and manipulate
 RRDs.

Package: rrdcached
Architecture: linux-any kfreebsd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: data caching daemon for RRDtool
 RRDCacheD is a daemon that receives updates to existing RRD files, accumulates
 them and, if enough have been received or a defined time has passed, writes
 the updates to the RRD file. The daemon was written with big setups in mind.
 Those setups usually run into I/O related problems. RRDCacheD's goal is to
 alleviate these problems.

Package: rrdtool-dbg
Architecture: any
Multi-Arch: same
Priority: extra
Section: debug
Depends: librrd4 (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: librrds-perl (= ${binary:Version}),
            lua-rrd (= ${binary:Version}),
            python-all-dbg,
            python-rrdtool (= ${binary:Version}),
            rrdtool (= ${binary:Version}),
            rrdtool-tcl (= ${binary:Version}),
            ruby-rrd (= ${binary:Version})
Description: time-series data storage and display system (debugging symbols)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 RRDtool is often used via various wrappers that can poll data from devices
 and feed data into RRDs, as well as provide a friendlier user interface and
 customized graphs.
 .
 This package contains the debugging symbols for the program and library files.

Package: librrd4
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: fonts-dejavu-core | ttf-bitstream-vera
Description: time-series data storage and display system (runtime library)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains shared libraries used to access and manipulate RRDs.

Package: librrd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: librrd4 (= ${binary:Version}), ${misc:Depends}
Description: time-series data storage and display system (development)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains header files and libraries used to develop software
 that uses RRDs.

Package: librrds-perl
Architecture: any
Multi-Arch: same
Section: perl
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Description: time-series data storage and display system (Perl interface, shared)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains a Perl interface to RRDs using a shared library.

Package: librrdp-perl
Architecture: all
Section: perl
Depends: rrdtool, ${misc:Depends}, ${perl:Depends}
Description: time-series data storage and display system (Perl interface, piped)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains a Perl interface to RRDs using command pipes.

Package: rrdtool-tcl
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, ${tcl:Depends}
Description: time-series data storage and display system (Tcl interface)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains a Tcl interface to RRDs.

Package: python-rrdtool
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Provides: ${python:Provides}
Description: time-series data storage and display system (Python interface)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains a Python interface to RRDs.

Package: ruby-rrd
Architecture: any
Multi-Arch: same
Section: ruby
XB-Ruby-Versions: ${ruby:Versions}
X-DhRuby-Root: bindings/ruby
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: time-series data storage and display system (Ruby interfaces)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains a Ruby interfaces to RRDs.

Package: lua-rrd
Architecture: any
Multi-Arch: same
Section: interpreters
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: liblua5.1-rrd0 (<< 1.5.4-3~)
Breaks: liblua5.1-rrd0 (<< 1.5.4-3~)
Provides: liblua5.1-rrd0, ${lua:Provides}
Description: time-series data storage and display system (Lua interfaces)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains the Lua interfaces to RRDs.

Package: lua-rrd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: lua-rrd (= ${binary:Version}), ${misc:Depends}
Replaces: liblua5.1-rrd-dev (<< 1.5.4-3~)
Breaks: liblua5.1-rrd-dev (<< 1.5.4-3~)
Provides: liblua5.1-rrd-dev, ${lua:Provides}
Description: time-series data storage and display system (Lua development)
 The Round Robin Database Tool (RRDtool) is a system to store and display
 time-series data (e.g. network bandwidth, machine-room temperature,
 server load average). It stores the data in Round Robin Databases (RRDs),
 a very compact way that will not expand over time. RRDtool processes the
 extracted data to enforce a certain data density, allowing for useful
 graphical representation of data values.
 .
 This package contains development files for the Lua interfaces to RRDs.

Package: liblua5.1-rrd0
Architecture: all
Section: oldlibs
Priority: extra
Depends: lua-rrd, ${misc:Depends}
Description: Transitional package to lua-rrd
 This is a transitional package for liblua5.1-rrd0 to ease upgrades
 to the lua-rrd package. It can safely be removed.

Package: liblua5.1-rrd-dev
Architecture: all
Section: oldlibs
Priority: extra
Depends: lua-rrd-dev, ${misc:Depends}
Description: Transitional package to lua-rrd-dev
 This is a transitional package for liblua5.1-rrd-dev to ease upgrades
 to the lua-rrd-dev package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Helps reproducible builds, and required by some tests (first day of week):
export LANG=C.UTF-8
export LC_ALL=C.UTF-8
export TZ=UTC

#tcl version we're building for
TCL_VERS := $(shell dpkg -s tcl-dev | grep '^Depends' \
	| sed 's,.*\<tcl\([0-9.]*\)-dev\>.*,\1,')

DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Use the date of the changelog as a build date:
BUILD_DATETIME := $(shell dpkg-parsechangelog -S Date)
BUILD_DATE := $(shell date -u --date="$(BUILD_DATETIME)" +%F)
BUILD_TIME := $(shell date -u --date="$(BUILD_DATETIME)" +%T)
export DEB_CPPFLAGS_MAINT_APPEND=-DBUILD_DATE='"$(BUILD_DATE)"' -DBUILD_TIME='"$(BUILD_TIME)"'  # C
export BUILD_DATE BUILD_TIME  # For docs/Makefile.am

# Bindings perls-shared and ruby need this:
export ABS_TOP_SRCDIR=$(CURDIR)
export ABS_TOP_BUILDDIR=$(CURDIR)

%:
	dh $@ --with autoreconf,lua,python2,ruby

override_dh_auto_configure:
	dh_auto_configure -- \
	 --disable-silent-rules \
	 --disable-rpath \
	 --disable-lua \
	 --disable-perl \
	 --disable-python \
	 --disable-ruby \
	 --with-tcllib=/usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(TCL_VERS) \
	 RRDDOCDIR=/usr/share/doc/rrdtool
	dh_auto_configure --buildsystem=lua
	dh_auto_configure --sourcedirectory=bindings/perl-shared
	dh_auto_configure --sourcedirectory=bindings/perl-piped
	dh_auto_configure --sourcedirectory=bindings/python
	dh_auto_configure --buildsystem=ruby

override_dh_auto_clean:
	dh_auto_clean --buildsystem=lua
	dh_auto_clean --sourcedirectory=bindings/perl-shared
	dh_auto_clean --sourcedirectory=bindings/perl-piped
	dh_auto_clean --sourcedirectory=bindings/python
	dh_auto_clean --buildsystem=ruby
	dh_auto_clean  # Must be called last, after other debhelper's clean

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --buildsystem=lua
	dh_auto_build --sourcedirectory=bindings/perl-shared
	dh_auto_build --sourcedirectory=bindings/perl-piped
	dh_auto_build --sourcedirectory=bindings/python
	dh_auto_build --buildsystem=ruby
	# Fix library path to tcl bindings:
	sed -i -e 's|lib/|lib/tcltk/|' -e 's|/tclrrd|/rrdtool-tcl/tclrrd|' bindings/tcl/pkgIndex.tcl

override_dh_auto_test:
	dh_auto_test
	# rrdcached doesn't work on hurd yet:
	# sigwaitinfo exists, but returns ENOSYS (not implemented)
	test $(shell dpkg-architecture -qDEB_HOST_ARCH_OS) = hurd \
	  || dh_auto_test -- TESTS_STYLE="rrdcached"
	dh_auto_test --buildsystem=lua
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$$LD_LIBRARY_PATH:}$(CURDIR)/src/.libs \
	 dh_auto_test --sourcedirectory=bindings/perl-shared
	dh_auto_test --sourcedirectory=bindings/perl-piped
	dh_auto_test --sourcedirectory=bindings/python
	dh_auto_test --buildsystem=ruby

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem=lua
	dh_auto_install --sourcedirectory=bindings/perl-shared
	dh_auto_install --sourcedirectory=bindings/perl-piped
	dh_auto_install --sourcedirectory=bindings/python
	dh_auto_install --buildsystem=ruby

override_dh_install:
	# We don't install systemd files yet, because it changes socket location.
	# This may need a transition with other packages (TODO).
	dh_install -X.la -X.txt -X.pod -Xsystemd --fail-missing

override_dh_installdocs:
	dh_installdocs -A CONTRIBUTORS NEWS

override_dh_strip:
	dh_strip --dbg-package=rrdtool-dbg

override_dh_gencontrol:
	tcltk-depends
	dh_gencontrol
